# $Id$
# 
# @Copyright@
# 
# 				Rocks(r)
# 		         www.rocksclusters.org
# 		         version 5.5 (Mamba)
# 		         version 6.0 (Mamba)
# 
# Copyright (c) 2000 - 2012 The Regents of the University of California.
# All rights reserved.	
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice unmodified and in its entirety, this list of conditions and the
# following disclaimer in the documentation and/or other materials provided 
# with the distribution.
# 
# 3. All advertising and press materials, printed or electronic, mentioning
# features or use of this software must display the following acknowledgement: 
# 
# 	"This product includes software developed by the Rocks(r)
# 	Cluster Group at the San Diego Supercomputer Center at the
# 	University of California, San Diego and its contributors."
# 
# 4. Except as permitted for the purposes of acknowledgment in paragraph 3,
# neither the name or logo of this software nor the names of its
# authors may be used to endorse or promote products derived from this
# software without specific prior written permission.  The name of the
# software includes the following terms, and any derivatives thereof:
# "Rocks", "Rocks Clusters", and "Avalanche Installer".  For licensing of 
# the associated name, interested parties should contact Technology 
# Transfer & Intellectual Property Services, University of California, 
# San Diego, 9500 Gilman Drive, Mail Code 0910, La Jolla, CA 92093-0910, 
# Ph: (858) 534-5815, FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu
# 
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
# IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# @Copyright@
#

import rocks.commands

"""This plugin configure osg condor for submission of for execution based
upon exec_host and submit_host attribute values.
"""

class Plugin(rocks.commands.Plugin):

	def provides(self):
		return 'exec_submit'

	def run(self, argv):
		# 1. Get the hostname and the key-value store, which
		#    is a python dictionary 
		host, kvstore = argv 

		exec_host = self.db.getHostAttr(host, 'exec_host')
		
		if exec_host == 'true':
			if not "STARTD" in kvstore['DAEMON_LIST']:
				kvstore['DAEMON_LIST'] = kvstore['DAEMON_LIST'] + ", STARTD"
		elif exec_host == 'false':
			if "STARTD" in kvstore['DAEMON_LIST']:
				temp = [  ]
				for i in kvstore['DAEMON_LIST'].split(','):
					if "STARTD" not in i:
						temp.append(i)
				kvstore['DAEMON_LIST'] = ','.join(temp)
		#elif == None do nothing

		submit_host = self.db.getHostAttr(host, 'submit_host')
		if submit_host == 'true':
			if not "SCHEDD" in kvstore['DAEMON_LIST']:
				kvstore['DAEMON_LIST'] = kvstore['DAEMON_LIST'] + ", SCHEDD"
			kvstore['HOSTALLOW_NEGOTIATOR_SCHEDD'] = '$(HOSTALLOW_NEGOTIATOR_SCHEDD), $(HOSTALLOW_WRITE)'
		elif submit_host == 'false':
			if "SCHEDD" in kvstore['DAEMON_LIST']:
				temp = [  ]
				for i in kvstore['DAEMON_LIST'].split(','):
					if "SCHEDD" not in i:
						temp.append(i)
				kvstore['DAEMON_LIST'] = ','.join(temp)


				
				


				


RollName = "osg"
